#!/bin/sh
# Generate all feature files for one or more XMOD files

# TODO: This must point to the current directory!!!
#SPATH=/Users/lowd/Documents/Projects/dn2features/scripts
SPATH=.

if [ $# -lt 1 ]; then
  echo "Usage: genfeatures.sh <xmod file> ..."
  exit -1
fi

while [ $# -gt 0 ]; do
  xmod=$1
  shift
  i=`basename $xmod '.xmod'`
  d=`dirname $xmod`
  $SPATH/src/bn2features $xmod | $SPATH/scripts/resort.pl      | sort | uniq > ${d}/${i}_xmod_rules.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts.pl    | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts-5.pl  | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune5.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts-10.pl | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune10.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/remzeroes.pl   | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_nonzero.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts.pl    | $SPATH/scripts/remzeroes.pl | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune_nonzero.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts-5.pl  | $SPATH/scripts/remzeroes.pl | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune5_nonzero.txt
  $SPATH/src/bn2features $xmod | $SPATH/scripts/prunedts-10.pl | $SPATH/scripts/remzeroes.pl | $SPATH/scripts/resort.pl | sort | uniq > ${d}/${i}_xmod_rules_dtprune10_nonzero.txt
done
