#ifndef LEARNWTS_H_NOV_23_2005
#define LEARNWTS_H_NOV_23_2005

#include <sys/time.h>
#include "rule.h"

class LearnWts{
 public:

  static Rule* parseRule(string buffer, bool hasWt){
    Rule* rule = new Rule(-1);
    Array<string> token;
    tokenize(buffer, token," ");
    int start = 0;
    if (hasWt){
      start = 1;
    }
    for(int ix  = start; ix < token.size(); ix++){
      Array<string> cond;
      tokenize(token[ix],cond,":");

      int index = atoi(cond[0].c_str());
      int value = atoi(cond[1].c_str());
      rule->addValue(value,index);//index,value);                                   

    }

    return rule;
  }

  static Rule* parseRule(string buffer, bool hasWt, Array<double>* wts, int idx){
    Rule* rule = new Rule(-1);
    Array<string> token;
    tokenize(buffer, token," ");
    int start = 0;
    if (hasWt){
      start = 1;
      double wt = atof(token[0].c_str());
      (*wts)[idx] = wt;
    }
    for(int ix  = start; ix < token.size(); ix++){
      Array<string> cond;
      tokenize(token[ix],cond,":");

      int index = atoi(cond[0].c_str());
      int value = atoi(cond[1].c_str());
      rule->addValue(value,index);//index,value);                                   

    }

    return rule;
  }

  static Array<int>* parseExample(string buffer){
    Array<int>* ex = new Array<int>;
    Array<string> token;
    tokenize(buffer, token,",");
    for(int ix  = 0; ix < token.size(); ix++){
      ex->append(atoi(token[ix].c_str()));
    }
    return ex;
  }
  static void tokenize(const string& str,
		Array<string>& tokens,
		const string& delimiters = " ")
  {
    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".1
    string::size_type pos     = str.find_first_of(delimiters, lastPos);
    
    while (string::npos != pos || string::npos != lastPos)
      {
	// Found a token, add it to the vector.
	tokens.append(str.substr(lastPos, pos - lastPos));
	// Skip delimiters.  Note the "not_of"
	lastPos = str.find_first_not_of(delimiters, pos);
      // Find next "non-delimiter"
	pos = str.find_first_of(delimiters, lastPos);
      }
  }
};

#endif
